Package org.apache.sysds.parser

# Class DataIdentifier

java.lang.Object
org.apache.sysds.parser.Expression
org.apache.sysds.parser.Identifier
org.apache.sysds.parser.DataIdentifier

All Implemented Interfaces:
  `ParseInfo`

Direct Known Subclasses:
  `BuiltinFunctionExpression`, `DataExpression`, `FunctionCallIdentifier`, `IndexedIdentifier`, `MetaDataAll`, `ParameterizedBuiltinFunctionExpression`

public class DataIdentifier extends Identifier

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.sysds.parser.Expression

`Expression.BinaryOp, Expression.BooleanOp, Expression.DataOp, Expression.FunctCallOp, Expression.RelationalOp`

## Constructor Summary

Constructors
Constructor
Description
`DataIdentifier()`
`DataIdentifier(String name)`
`DataIdentifier(String name, Types.DataType dt)`
`DataIdentifier(String name, Types.DataType dt, Types.ValueType vt)`
`DataIdentifier(DataIdentifier passed)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object that)`
`String`
`getName()`
`int`
`hashCode()`
`boolean`
`multipleReturns()`
Method to specify if an expression returns multiple outputs.
`Expression`
`rewriteExpression(String prefix)`
`void`
`setName(String name)`
`String`
`toString()`
`VariableSet`
`variablesRead()`
`VariableSet`
`variablesUpdated()`

### Methods inherited from class org.apache.sysds.parser.Identifier

`computeDataType, dimsKnown, getBlocksize, getDataType, getDim1, getDim2, getFileFormat, getNnz, getValueType, isScalarBoolean, setBlocksize, setBooleanProperties, setDataType, setDimensions, setDimensionValueProperties, setFileFormat, setIntProperties, setNnz, setProperties, setValueType, validateExpression`

### Methods inherited from class org.apache.sysds.parser.Expression

`computeDataType, computeDataType, computeValueType, computeValueType, computeValueType, convertFormatType, getBeginColumn, getBeginLine, getBinaryMatrixCharacteristics, getBinaryOp, getBooleanOp, getEndColumn, getEndLine, getFilename, getOutput, getOutputs, getParseExceptionList, getRelationalOp, getTempName, getText, printErrorLocation, printInfoLocation, printWarningLocation, raiseValidateError, raiseValidateError, raiseValidateError, setBeginColumn, setBeginLine, setCtxValues, setCtxValuesAndFilename, setEndColumn, setEndLine, setFilename, setOutput, setParseExceptionList, setParseInfo, setText, validateExpression`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### DataIdentifier

public DataIdentifier(DataIdentifier passed)

### DataIdentifier

public DataIdentifier(String name)

### DataIdentifier

public DataIdentifier(String name, Types.DataType dt)

### DataIdentifier

public DataIdentifier(String name, Types.DataType dt, Types.ValueType vt)

### DataIdentifier

public DataIdentifier()

## Method Details

### rewriteExpression

public Expression rewriteExpression(String prefix)

Specified by:
  `rewriteExpression` in class `Expression`

### getName

public String getName()

### setName

public void setName(String name)

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### variablesRead

public VariableSet variablesRead()

Specified by:
  `variablesRead` in class `Expression`

### variablesUpdated

public VariableSet variablesUpdated()

Specified by:
  `variablesUpdated` in class `Expression`

### multipleReturns

public boolean multipleReturns()
Method to specify if an expression returns multiple outputs. This method must be overridden by all child classes.

Returns:
  true if expression returns multiple outputs

### equals

public boolean equals(Object that)

Overrides:
  `equals` in class `Expression`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Expression`